<?php
/***************************************************************
 *  Copyright notice
 *
 *  (c) 2013 IMIA net based solutions (info@imia.de)
 *  All rights reserved
 *
 *  This script is part of the TYPO3 project. The TYPO3 project is
 *  free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  The GNU General Public License can be found at
 *  http://www.gnu.org/copyleft/gpl.html.
 *
 *  This script is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  This copyright notice MUST APPEAR in all copies of the script!
 ***************************************************************/

if (!defined('TYPO3_MODE')) {
    die ('Access denied.');
}

\IMIA\ImiaComposer\Utility\Composer::fetch();
\IMIA\ImiaBaseExt\Utility\DynamicConfiguration::build('localconf');

$GLOBALS['TYPO3_CONF_VARS']['SC_OPTIONS']['GLOBAL']['extTablesInclusion-PostProcessing'][$_EXTKEY] =
    'IMIA\ImiaBaseExt\Hook\TableConfigurationPostProcessing';

$GLOBALS['TYPO3_CONF_VARS']['SYS']['lang']['cache']['clear_menu'] = true;

/* Hooks */
$GLOBALS['TYPO3_CONF_VARS']['EXTCONF']['extbase']['typeConverters'][] =
    'IMIA\ImiaBaseExt\Hook\ArrayConverter';

$GLOBALS['TYPO3_CONF_VARS']['SC_OPTIONS']['t3lib/class.t3lib_tcemain.php']['clearCachePostProc']['tx_imiabaseext'] =
    'IMIA\ImiaBaseExt\Hook\DataHandler->clearCachePostProc';

if (!class_exists('IMIA\ImiaBaseExt\Hook\DataHandler')) {
    require_once(\TYPO3\CMS\Core\Utility\ExtensionManagementUtility::extPath($_EXTKEY, 'Classes/Hook/DataHandler.php'));
}

$GLOBALS['TYPO3_CONF_VARS']['SC_OPTIONS']['additionalBackendItems']['cacheActions']['tx_imiabaseext'] =
    'IMIA\ImiaBaseExt\Hook\ClearCacheActions';

/* Xclasses */
$GLOBALS['TYPO3_CONF_VARS']['SYS']['Objects']['TYPO3\CMS\Extbase\Property\TypeConverter\PersistentObjectConverter'] = [
    'className' => 'IMIA\ImiaBaseExt\Xclass\Extbase\Property\TypeConverter\PersistentObjectConverter',
];
$GLOBALS['TYPO3_CONF_VARS']['SYS']['Objects']['TYPO3\CMS\Backend\Configuration\TypoScript\ConditionMatching\ConditionMatcher'] = [
    'className' => 'IMIA\ImiaBaseExt\Xclass\Backend\Configuration\TypoScript\ConditionMatching\ConditionMatcher',
];
$GLOBALS['TYPO3_CONF_VARS']['SYS']['Objects']['TYPO3\CMS\Backend\Form\FormDataProvider\EvaluateDisplayConditions'] = [
    'className' => 'IMIA\ImiaBaseExt\Xclass\Backend\Form\FormDataProvider\EvaluateDisplayConditions',
];
$GLOBALS['TYPO3_CONF_VARS']['SYS']['Objects']['TYPO3\CMS\Backend\Form\FormDataProvider\TcaRecordTitle'] = [
    'className' => 'IMIA\ImiaBaseExt\Xclass\Backend\Form\FormDataProvider\TcaRecordTitle',
];
$GLOBALS['TYPO3_CONF_VARS']['SYS']['Objects']['TYPO3\CMS\Backend\Form\Element\SelectCheckBoxElement'] = [
    'className' => 'IMIA\ImiaBaseExt\Xclass\Backend\Form\Element\SelectCheckBoxElement',
];
$GLOBALS['TYPO3_CONF_VARS']['SYS']['Objects']['TYPO3\CMS\Backend\Template\ModuleTemplate'] = [
    'className' => 'IMIA\ImiaBaseExt\Xclass\Backend\Template\ModuleTemplate',
];
$GLOBALS['TYPO3_CONF_VARS']['SYS']['Objects']['TYPO3\CMS\Extbase\Persistence\Generic\Backend'] = [
    'className' => 'IMIA\ImiaBaseExt\Xclass\Extbase\Persistence\Generic\Backend',
];
$GLOBALS['TYPO3_CONF_VARS']['SYS']['Objects']['TYPO3\CMS\Extensionmanager\Controller\ConfigurationController'] = [
    'className' => 'IMIA\ImiaBaseExt\Xclass\Extensionmanager\Controller\ConfigurationController',
];
$GLOBALS['TYPO3_CONF_VARS']['SYS']['Objects']['TYPO3\CMS\Extensionmanager\Utility\ConfigurationUtility'] = [
    'className' => 'IMIA\ImiaBaseExt\Xclass\Extensionmanager\Utility\ConfigurationUtility',
];
$GLOBALS['TYPO3_CONF_VARS']['SYS']['Objects']['TYPO3\CMS\Extensionmanager\Domain\Repository\ConfigurationItemRepository'] = [
    'className' => 'IMIA\ImiaBaseExt\Xclass\Extensionmanager\Domain\Repository\ConfigurationItemRepository',
];
$GLOBALS['TYPO3_CONF_VARS']['SYS']['Objects']['TYPO3\CMS\Extensionmanager\ViewHelpers\Form\TypoScriptConstantsViewHelper'] = [
    'className' => 'IMIA\ImiaBaseExt\Xclass\Extensionmanager\ViewHelpers\Form\TypoScriptConstantsViewHelper',
];
$GLOBALS['TYPO3_CONF_VARS']['SYS']['Objects']['TYPO3\CMS\Fluid\ViewHelpers\Be\Menus\ActionMenuViewHelper'] = [
    'className' => 'IMIA\ImiaBaseExt\Xclass\Fluid\ViewHelpers\Be\Menus\ActionMenuViewHelper',
];
$GLOBALS['TYPO3_CONF_VARS']['SYS']['Objects']['TYPO3\CMS\Frontend\Imaging\GifBuilder'] = [
    'className' => 'IMIA\ImiaBaseExt\Xclass\Frontend\Imaging\GifBuilder',
];
$GLOBALS['TYPO3_CONF_VARS']['SYS']['Objects']['TYPO3\CMS\Core\DataHandling\DataHandler'] = [
    'className' => 'IMIA\ImiaBaseExt\Xclass\Core\DataHandling\DataHandler',
];
$GLOBALS['TYPO3_CONF_VARS']['SYS']['Objects']['TYPO3\CMS\Install\Service\SqlExpectedSchemaService'] = [
    'className' => 'IMIA\ImiaBaseExt\Xclass\Install\Service\SqlExpectedSchemaService',
];
$GLOBALS['TYPO3_CONF_VARS']['SYS']['Objects']['TYPO3\CMS\Install\Service\SqlSchemaMigrationService'] = [
    'className' => 'IMIA\ImiaBaseExt\Xclass\Install\Service\SqlSchemaMigrationService',
];

// extbase query parsing (onlyFields)
$GLOBALS['TYPO3_CONF_VARS']['SYS']['Objects']['TYPO3\CMS\Extbase\Persistence\Generic\Typo3QuerySettings'] = [
    'className' => 'IMIA\ImiaBaseExt\Xclass\Extbase\Persistence\Generic\Typo3QuerySettings',
];
$GLOBALS['TYPO3_CONF_VARS']['SYS']['Objects']['TYPO3\CMS\Extbase\Persistence\Generic\Storage\Typo3DbQueryParser'] = [
    'className' => 'IMIA\ImiaBaseExt\Xclass\Extbase\Persistence\Generic\Storage\Typo3DbQueryParser',
];
$GLOBALS['TYPO3_CONF_VARS']['SYS']['Objects']['TYPO3\CMS\Extbase\Persistence\Generic\Storage\Typo3DbBackend'] = [
    'className' => 'IMIA\ImiaBaseExt\Xclass\Extbase\Persistence\Generic\Storage\Typo3DbBackend',
];
$GLOBALS['TYPO3_CONF_VARS']['SYS']['Objects']['TYPO3\CMS\Extbase\Persistence\Generic\Mapper\DataMapper'] = [
    'className' => 'IMIA\ImiaBaseExt\Xclass\Extbase\Persistence\Generic\Mapper\DataMapper',
];
$GLOBALS['TYPO3_CONF_VARS']['SYS']['Objects']['TYPO3\CMS\Extbase\Persistence\Generic\Session'] = [
    'className' => 'IMIA\ImiaBaseExt\Xclass\Extbase\Persistence\Generic\Session',
];
$GLOBALS['TYPO3_CONF_VARS']['SYS']['Objects']['TYPO3\CMS\Extbase\Configuration\BackendConfigurationManager'] = [
    'className' => 'IMIA\ImiaBaseExt\Xclass\Extbase\Configuration\BackendConfigurationManager',
];

if (!class_exists('Psr\Log\LoggerInterface') && !\TYPO3\CMS\Core\Utility\GeneralUtility::_GP('install')) {
    try {
        new \TYPO3\CMS\Core\Log\Logger(null);
    } catch (\Exception $e) {
        if (!function_exists('rrmdir')) {
            function rrmdir($dir)
            {
                if (!file_exists($dir)) {
                    return true;
                }
                if (!is_dir($dir)) {
                    return unlink($dir);
                }

                foreach (scandir($dir) as $item) {
                    if ($item != '.' && $item != '..') {
                        if (!rrmdir($dir . DIRECTORY_SEPARATOR . $item)) {
                            return false;
                        }
                    }
                }

                return rmdir($dir);
            }
        }

        @rrmdir(PATH_site . 'typo3temp/Cache/Data/cache_classes');
    }
}

\TYPO3\CMS\Core\Utility\ExtensionManagementUtility::addTypoScript($_EXTKEY, 'setup',
    'module.tx_extensionmanager {
        view.templateRootPath >
        view.templateRootPaths {
            1 = EXT:extensionmanager/Resources/Private/Templates
            99999 = EXT:imia_base_ext/Resources/Private/Extensions/extensionmanager/Templates
        }
    }', true);

$iconRegistry = \TYPO3\CMS\Core\Utility\GeneralUtility::makeInstance(\TYPO3\CMS\Core\Imaging\IconRegistry::class);
$iconRegistry->registerIcon('actions-system-cache-clear-extensions', \TYPO3\CMS\Core\Imaging\IconProvider\SvgIconProvider::class, [
    'source' => \TYPO3\CMS\Core\Utility\ExtensionManagementUtility::extPath('imia_base_ext') . 'Resources/Public/Images/CacheExt.svg',
]);